;----------------------------------------------------------------
; Mathematical Expression Evaluator (c) Tom Lindstrm
;
;   Deep Thought is a supercomputer created by a superrace to
;   answer "The Ultimate Question of Life, the Universe, and
;   Everything." Deep Thought gives an answer (the answer is
;   "42"), but no one knows how to pose the question so that
;   the answer can be understood.
;       -- Douglas Adams "The Hitchhiker's Guide to the Galaxy"
;----------------------------------------------------------------

COMMAND_LINE	EQU	0x82

SECTION	.text
	ORG	0x100

main:
	xor	ebx,ebx
	mov	bl,10

	mov	si,COMMAND_LINE+1
	call	expr

	xor	cx,cx
main_0:
	cdq
	idiv	ebx
	push	dx
	inc	cx
	test	eax,eax
	jnz	main_0

	test	dh,dh
	jz	main_1
	push	WORD 0xfd
	inc	cx
main_1:
	pop	dx
	test	dh,dh
	jz	main_2
	neg	dx
main_2:
	add	dl,'0'
	mov	ah,2
	int	21h
	loop	main_1
	ret

factor:
	xor	eax,eax
	cdq
	lodsb
	cmp	al,'-'
	jne	factor_0
	call	factor
	neg	eax
	ret
factor_0:
	cmp	al,'+'
	je	factor
	jnl	number_1
	inc	si
expr:
	push	edi
	xor	edi,edi
expr_0:
	dec	si
term:
	push	edi
	xor	edi,edi
	inc	di
term_0:
	call	factor
	imul	edi,eax
	jmp	SHORT term_2
term_1:
	call	factor
	xchg	eax,edi
	cdq
	idiv	edi
	mov	edi,eax
term_2:
	lodsb

	cmp	al,'*'
	je	term_0
	cmp	al,'/'
	je	term_1

	pop	edx
	add	edi,edx

	cmp	al,'+'
	je	term
	jg	expr_0

	mov	eax,edi
	pop	edi
	ret
number:
	imul	edx,BYTE 10
	add	edx,eax
	lodsb
number_1:
	sub	al,'0'
	jnc	number
	dec	si
	mov	eax,edx
	ret
